package com.react_sqlconnectionpackage.sqlconnection;

import android.accounts.Account;
import android.accounts.AccountManager;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;
import android.text.InputFilter;
import android.util.DisplayMetrics;
import android.util.Log;
import android.util.Patterns;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.File;
import java.lang.reflect.Field;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Locale;
import java.util.concurrent.TimeUnit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class CommonUtil {


    //	public static final String DATE_FORMAT = "yyyy-MM-dd";
    public static final String DATE_FORMAT = "dd-MMM-yyyy";
    public static final String DATE_FORMAT_DATABASE = "yyyy-MM-dd hh:mm:ss";
    public static final String DATE_FORMAT_DATABASEDDMMYYY = "yyyy-MM-dd";
    public static final String DATE_FORMAT_DATABASE_SEND = "yyyy-MM-dd";
    public static final String DATE_FORMAT_DD_MMM_YYYY = "dd/MM/yyyy";

    public static final String DATE_FORMAT_DDMMMYYY = "dd MMM yyyy";

    public static final int textCharLimit = 100; //80

    public static final SimpleDateFormat dateFormat = new SimpleDateFormat("dd-MMM-yyyy");


    public static String[] getDivideFullName(String name) {
        name = name.trim();
        int index = name.lastIndexOf(' ');
        String fname = "", lname = "", mname = "";
        if (index > 0) {
            fname = name.substring(0, index);
            lname = name.substring(index + 1, name.length());
        }

        name = fname.trim();
        index = name.indexOf(' ');
        if (index > 0) {
            fname = name.substring(0, index);
            mname = name.substring(index + 1, name.length());
        }

        return new String[]{fname, lname, mname};
    }

    public static long getDifferenceDays(Date d1, Date d2) {
        long diff = d2.getTime() - d1.getTime();
        return TimeUnit.DAYS.convert(diff, TimeUnit.MILLISECONDS);
    }

    /**
     * This method converts Date String from different format to dd/MM/yyy
     *
     * @param dateStr   : this is date String which user want to convert
     * @param formatStr : this is format of that dateStr Ex: dd-MMM-yyyy hh:mm:ss
     * @return it returns
     */
    public static String convertToDateString(String dateStr, String formatStr) {
        SimpleDateFormat sdf = new SimpleDateFormat(formatStr);
        SimpleDateFormat sdfTo = new SimpleDateFormat("dd-MMM-yyyy");

        String newDateStr = null;
        Date date;
        try {
            if (dateStr == null) {
                date = new Date(System.currentTimeMillis());
            } else {
                date = sdf.parse(dateStr);
            }
            newDateStr = sdfTo.format(date);
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }

    public static String convertToDateReport(String monthId, String dateStrfrom, String dateStrTo) {

        //Jan-2017(27-01-17 to 05-02-2017)
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_DATABASE);
        SimpleDateFormat sdfTo = new SimpleDateFormat("dd-MM-yyyy");
        SimpleDateFormat sdfStart = new SimpleDateFormat("MMM-yyyy");
        SimpleDateFormat sdfStartY = new SimpleDateFormat("-yyyy");

        String newDateStr = "";
        Date date;
        Date dateTo;
        try {
            if (dateStrfrom == null) {
                date = new Date(System.currentTimeMillis());
            } else {
                date = sdf.parse(dateStrfrom);
            }

            if (dateStrTo == null) {
                dateTo = new Date(System.currentTimeMillis());
            } else {
                dateTo = sdf.parse(dateStrTo);
            }

            newDateStr = getMonthName(monthId);

            if (newDateStr.length() > 0) {
                newDateStr = newDateStr + sdfStartY.format(dateTo);
            } else {
                newDateStr = newDateStr + sdfStart.format(dateTo);
            }

            newDateStr = newDateStr + "(";
            newDateStr = newDateStr + sdfTo.format(date);

            newDateStr = newDateStr + " to " + sdfTo.format(dateTo) + ")";
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }


    public static String getMonthName(String monthId) {

        String monthName = "";
        try {

            int monId = 0;

            try {
                monId = Integer.parseInt(monthId);
            } catch (Exception e) {
                e.printStackTrace();
            }

            switch (monId) {

                case 1:
                    monthName = "Jan";
                    break;
                case 2:
                    monthName = "Feb";
                    break;
                case 3:
                    monthName = "Mar";
                    break;
                case 4:
                    monthName = "Apr";
                    break;
                case 5:
                    monthName = "May";
                    break;
                case 6:
                    monthName = "Jun";
                    break;
                case 7:
                    monthName = "Jul";
                    break;
                case 8:
                    monthName = "Aug";
                    break;
                case 9:
                    monthName = "Sep";
                    break;
                case 10:
                    monthName = "Oct";
                    break;
                case 11:
                    monthName = "Nov";
                    break;
                case 12:
                    monthName = "Dec";
                    break;

            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        return monthName;
    }


    public static String convertToYYYYMMDD(String fromdate) {
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_DATABASE);
        SimpleDateFormat sdfTo = new SimpleDateFormat(DATE_FORMAT_DD_MMM_YYYY);
        ;

        String newDateStr = "";
        Date date;
        try {
            if (fromdate == null || fromdate.equalsIgnoreCase("null")) {
                return "";
            } else {
                date = sdf.parse(fromdate);
            }
            newDateStr = sdfTo.format(date);
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }

    public static String convertToDDMMMYYYFROMDB(String fromdate) {
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_DATABASE);
        SimpleDateFormat sdfTo = dateFormat;

        String newDateStr = "";
        Date date;
        try {
            if (fromdate == null || fromdate.equalsIgnoreCase("null")) {
                return "";
            } else {
                date = sdf.parse(fromdate);
            }
            newDateStr = sdfTo.format(date);
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }

    public static String convertToDDMMMYYY(Date fromdate) {

        SimpleDateFormat sdfTo = dateFormat;

        String newDateStr = "";
        Date date;
        try {

            newDateStr = sdfTo.format(fromdate);
        } catch (Exception e) {

            printError(e);
        }

        return newDateStr;
    }

    public static boolean checkMaxSize(String data, int size) {

       if(data.length()>size){

           return  true;
       }else{
           return  false;
       }


    }

    /**
     * This method converts Date String from different format to dd/MM/yyy
     *
     * @param dateStr   : this is date String which user want to convert
     * @param formatStr : this is format of that dateStr Ex: dd-MMM-yyyy hh:mm:ss
     * @return it returns
     */
    public static String convertToDBDate(String dateStr, String formatStr) {
        SimpleDateFormat sdf = new SimpleDateFormat(formatStr);
        SimpleDateFormat sdfTo = new SimpleDateFormat("yyyy/MM/dd");

        String newDateStr = null;
        Date date;
        try {
            if (dateStr == null) {
                date = new Date(System.currentTimeMillis());
            } else {
                date = sdf.parse(dateStr);
            }
            newDateStr = sdfTo.format(date);
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }

    /**
     * This method converts Date String from different format to dd/MM/yyy
     *
     * @param dateStr   : this is date String which user want to convert
     * @param formatStr : this is format of that dateStr Ex: dd-MMM-yyyy hh:mm:ss
     * @return it returns
     */
    public static String convertStringDateFormat(String dateStr, String formatStr, String toFormatStr) {
        SimpleDateFormat sdf = new SimpleDateFormat(formatStr);
        SimpleDateFormat sdfTo = new SimpleDateFormat(toFormatStr);

        String newDateStr = null;
        Date date;
        try {
            if (dateStr == null) {
                date = new Date(System.currentTimeMillis());
            } else {
                date = sdf.parse(dateStr);
            }
            newDateStr = sdfTo.format(date);
        } catch (ParseException e) {

            printError(e);
        }

        return newDateStr;
    }

    /**
     * Return String as per given format
     *
     * @param date      Date object
     * @param formatStr return format dateStr Ex: dd-MMM-yyyy hh:mm:ss
     * @return String date format
     */
    public static String formatDate(Date date, String formatStr) {
        SimpleDateFormat sdf = new SimpleDateFormat(formatStr);
        String newDateStr = sdf.format(date);
        return newDateStr;
    }


    public static String getCurrantDatabaseDate(Date date) {
        String newDateStr = "";
        try {
            SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_DATABASE);
            newDateStr = sdf.format(date);
        } catch (Exception e) {
            printError(e);
        }

        return newDateStr;
    }

    public static String getCurrantDatabaseDateDDMMYYYY(Date date) {
        String newDateStr = "";
        try {
            SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_DATABASEDDMMYYY);
            newDateStr = sdf.format(date);
        } catch (Exception e) {
            printError(e);
        }

        return newDateStr;
    }


    public static Date getDateFromString(String strDate, String format) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(format);
        Date date = null;
        try {
            date = simpleDateFormat.parse(strDate);
        } catch (ParseException ex) {
            System.out.println("Exception " + ex);
        }
        return date;
    }


    public static Date getDateFromDBString(String strDate) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(DATE_FORMAT_DATABASE);
        Date date = null;
        try {
            date = simpleDateFormat.parse(strDate);
        } catch (ParseException ex) {
            System.out.println("Exception " + ex);
        }
        return date;
    }

    public static String getNextDateFromGiven(String strDate, int days) {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(DATE_FORMAT_DATABASE);
        Date date = null;
        try {
            date = simpleDateFormat.parse(strDate);
        } catch (ParseException ex) {
            System.out.println("Exception " + ex);
        }
//		return date;

        Calendar c = Calendar.getInstance();
        c.setTime(date); // Now use today date.
        c.add(Calendar.DATE, days); // Adding 5 days
        String output = simpleDateFormat.format(c.getTime());
        return output;
    }

    public static String getFileNameFromURL(String url) {
        String fileName = url.substring(url.lastIndexOf('/') + 1, url.length());
        return fileName;
    }

    public static String getFormatURL(String url) {
        if (url != null) {
            /*if (!(url.Contains("http://") || url.Contains("https://")))
				url = "http://" + url;*/
            if (!(url.contains("http://") || url.contains("https://"))) {
                url = "http://" + url;
            }
            url = url.replaceAll(" ", "%20");
        } else {
            return "";
        }
        return url;
    }

    public static String getFormatLocalURL(String url) {
        if (url != null) {
			/*if (!(url.Contains("http://") || url.Contains("https://")))
				url = "http://" + url;*/
			/*if(!(url.contains("http://") || url.contains("https://"))){
				url = "http://" + url;
			}*/

            try {
                url = Uri.encode(url);

            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
            return "";
        }
        return url;
    }

    public static void printError(Exception e) {
        e.printStackTrace();
    }

    public static void printMessage(String msg) {
        if (msg != null) {
            Log.d("Aria Lib", msg);
        }
    }

    public static void showToast(Context context, String msg) {
        Toast.makeText(context, msg, Toast.LENGTH_LONG).show();
    }

    /**
     * This method shows custom toast which is showing some UI
     *
     * @param context is Context of activity
     * @param msg     : message to show
     * @param isError : set 'true' when you want to show error, set 'false' when
     *                want to show information
     */

    public static void showCustomToast(Context context, String msg,
                                       boolean isError) {
        // Retrieve the layout inflator
/*		if (toastFlag) {
			return;
		}

		LayoutInflater inflater = ((Activity) context).getLayoutInflater();
		View layout = inflater.inflate(R.layout.toast_custom_layout,
				(ViewGroup) ((Activity) context)
						.findViewById(R.id.toast_layout_root));
		TextView text = (TextView) layout.findViewById(R.id.textToast);
		// text.setTypeface(typeface_obj);

		if (isError) {
			layout.setBackgroundResource(R.drawable.toast_red);
		} else {
			layout.setBackgroundResource(R.drawable.toast_green);
		}
		text.setText(msg);

		// Return the application context
		Toast toast = new Toast(context);
		// Set toast gravity to bottom
		toast.setGravity(Gravity.BOTTOM, 0, 0);
		// Set toast duration
		toast.setDuration(Toast.LENGTH_SHORT);
		// Set the custom layout to Toast
		toast.setView(layout);
		// Display toast
		toast.show();
		toastFlag = true;
		h = new Handler();
		h.postDelayed(thread, 3000);*/

        Toast.makeText(context, msg, Toast.LENGTH_LONG).show();
		/*Toast toast= Toast.makeText(context,
				msg, Toast.LENGTH_LONG);
		toast.setGravity(Gravity.TOP|Gravity.CENTER_HORIZONTAL, 0, 0);
		toast.show();*/

    }

    private static Handler h;
    public static boolean toastFlag;

    private static Runnable thread = new Runnable() {

        @Override
        public void run() {

            toastFlag = false;
        }
    };

    public static boolean isNetworkAvailable(Context con) {

        boolean haveConnectedWifi = false;
        boolean haveConnectedMobile = false;

        ConnectivityManager cm = (ConnectivityManager) con
                .getSystemService(Context.CONNECTIVITY_SERVICE);

        NetworkInfo[] netInfo = cm.getAllNetworkInfo();
        for (NetworkInfo ni : netInfo) {
            if (ni.getTypeName().equalsIgnoreCase("WIFI"))
                if (ni.isConnected())
                    haveConnectedWifi = true;
            if (ni.getTypeName().equalsIgnoreCase("MOBILE"))
                if (ni.isConnected())
                    haveConnectedMobile = true;
        }

        NetworkInfo activeNetwork = cm.getActiveNetworkInfo();
        boolean isConnected;
        if (activeNetwork != null)
            isConnected = activeNetwork.isConnectedOrConnecting();
        else
            isConnected = false;

        return haveConnectedWifi || haveConnectedMobile || isConnected;
    }

    public static String getSharePreferenceString(Context context, String key,
                                                  String defaultValue) {
        SharedPreferences setting = PreferenceManager
                .getDefaultSharedPreferences(context);
        return setting.getString(key, defaultValue);
    }

    public static void setSharePreferenceString(Context context, String key,
                                                String value) {
        SharedPreferences setting = PreferenceManager
                .getDefaultSharedPreferences(context);
        SharedPreferences.Editor editor = setting.edit();

        if (value.equals("")) {
            editor.remove(key);
        } else {
            editor.putString(key, value);
        }
        editor.commit();
    }

    public static void clearSharePreference(Context context) {

        try {
            SharedPreferences setting = PreferenceManager
                    .getDefaultSharedPreferences(context);
            SharedPreferences.Editor editor = setting.edit();
            editor.clear();
            editor.commit();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public static String getEmailAccount(Context context) {
        String email = null;

        Pattern emailPattern = Patterns.EMAIL_ADDRESS; // API level 8+
        Account[] accounts = AccountManager.get(context).getAccounts();
        for (Account account : accounts) {
            if (emailPattern.matcher(account.name).matches()) {
                email = account.name;
            }
        }

        return email;
    }

    public static boolean isEmailValid(String email) {
        boolean isValid = false;

        String expression = "^[\\w\\.-]+@([\\w\\-]+\\.)+[A-Z]{2,4}$";
        CharSequence inputStr = email;

        Pattern pattern = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(inputStr);
        if (matcher.matches()) {
            isValid = true;
        }
        return isValid;
    }

    public static String getIMEI(Context context) {

        TelephonyManager tm = (TelephonyManager) context
                .getSystemService(Context.TELEPHONY_SERVICE);
        String imei = null;
        if (tm != null) {
            imei = tm.getDeviceId();
            if (imei == null || imei.length() == 0)
                imei = Build.SERIAL;
        }
        return imei;
        // return "359299057653516";
    }

    public static String getDeviceName() {
        String manufacturer = Build.MANUFACTURER;
        String model = Build.MODEL;
        if (model.startsWith(manufacturer)) {
            return capitalize(model);
        } else {
            return capitalize(manufacturer) + " " + model;
        }
    }

    public static String capitalize(String s) {
        if (s == null || s.length() == 0) {
            return "";
        }
        char first = s.charAt(0);
        if (Character.isUpperCase(first)) {
            return s;
        } else {
            return Character.toUpperCase(first) + s.substring(1);
        }
    }

    public static String getDeviseOS() {
        StringBuilder builder = new StringBuilder();
        builder.append("Android - ").append(Build.VERSION.RELEASE);

        Field[] fields = Build.VERSION_CODES.class.getFields();
        for (Field field : fields) {
            String fieldName = field.getName();
            int fieldValue = -1;

            try {
                fieldValue = field.getInt(new Object());
            } catch (IllegalArgumentException e) {
                e.printStackTrace();
            } catch (IllegalAccessException e) {
                e.printStackTrace();
            } catch (NullPointerException e) {
                e.printStackTrace();
            }

            if (fieldValue == Build.VERSION.SDK_INT) {
                builder.append(" - ").append(fieldName);
            }
        }
        return builder.toString();
    }

    public static void setEnable(View view, boolean flag) {
        view.setClickable(flag);
        view.setEnabled(flag);
//		view.setFocusableInTouchMode(flag);
        view.setFocusable(flag);
    }

    public static void setListViewHeightBasedOnChildren(ScrollView scrollView, ListView listView) {
        try {


            ListAdapter listAdapter = listView.getAdapter();
            if (listAdapter == null)
                return;

            int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(),
                    View.MeasureSpec.UNSPECIFIED);
            int totalHeight = 0;
            View view = null;
            for (int i = 0; i < listAdapter.getCount(); i++) {
                view = listAdapter.getView(i, view, listView);
                if (i == 0)
                    view.setLayoutParams(new ViewGroup.LayoutParams(desiredWidth,
                            WindowManager.LayoutParams.WRAP_CONTENT));

                view.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);
                totalHeight += view.getMeasuredHeight();
            }
            totalHeight += 100;
            ViewGroup.LayoutParams params = listView.getLayoutParams();
        /*params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));*/
            params.height = totalHeight
                    + ((listView.getDividerHeight() + 1) * (listAdapter.getCount() + 1));
            params.height = params.height;
            listView.setLayoutParams(params);
            listView.requestLayout();
            scrollView.smoothScrollTo(0, 0);
        } catch (Exception e) {

        }
    }

    public static void setListViewHeightBasedOnChildrenLarge(ScrollView scrollView, ListView listView) {
        try {


            ListAdapter listAdapter = listView.getAdapter();
            if (listAdapter == null)
                return;

            int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(),
                    View.MeasureSpec.UNSPECIFIED);


            int totalHeight = 0;
            View view = null;
            for (int i = 0; i < listAdapter.getCount(); i++) {
                view = listAdapter.getView(i, view, listView);
                if (i == 0)
                    view.setLayoutParams(new ViewGroup.LayoutParams(desiredWidth,
                            WindowManager.LayoutParams.WRAP_CONTENT));

                //view.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);
                float px = 300 * (listView.getResources().getDisplayMetrics().density);
                view.measure(View.MeasureSpec.makeMeasureSpec((int) px, View.MeasureSpec.AT_MOST), View.MeasureSpec.makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED));

                totalHeight += view.getMeasuredHeight();

            }

            ViewGroup.LayoutParams params = listView.getLayoutParams();
        /*params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));*/
            params.height = totalHeight
                    + ((listView.getDividerHeight() + 1) * (listAdapter.getCount() + 1));
            params.height = params.height;
            listView.setLayoutParams(params);
            listView.requestLayout();
            scrollView.smoothScrollTo(0, 0);
        } catch (Exception e) {

        }
    }

    public static void setListViewHeightBasedOnChildrens(ScrollView scrollView, ListView listView) {

        try {


            ListAdapter listAdapter = listView.getAdapter();
            if (listAdapter == null) {
                // pre-condition
                return;
            }

            int totalHeight = 0;
            for (int i = 0; i < listAdapter.getCount(); i++) {
                View listItem = listAdapter.getView(i, null, listView);
                listItem.measure(0, 0);
                totalHeight += listItem.getMeasuredHeight();
            }

            ViewGroup.LayoutParams params = listView.getLayoutParams();
            params.height = totalHeight + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
            listView.setLayoutParams(params);
            listView.requestLayout();
            scrollView.smoothScrollTo(0, 0);
        } catch (Exception e) {

        }

    }

    public static void setListViewHeightBasedOnChildrenNormal(ListView listView) {
        ListAdapter listAdapter = listView.getAdapter();
        if (listAdapter == null)
            return;

        int desiredWidth = View.MeasureSpec.makeMeasureSpec(listView.getWidth(),
                View.MeasureSpec.UNSPECIFIED);
        int totalHeight = 0;
        View view = null;
        for (int i = 0; i < listAdapter.getCount(); i++) {
            view = listAdapter.getView(i, view, listView);
//			if (i == 0)
            view.setLayoutParams(new ViewGroup.LayoutParams(desiredWidth,
                    WindowManager.LayoutParams.WRAP_CONTENT));

            view.measure(desiredWidth, View.MeasureSpec.UNSPECIFIED);
            totalHeight += view.getMeasuredHeight();
        }
//		totalHeight +=10;
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        /*params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));*/
        params.height = totalHeight
        ;
        params.height = params.height;
        listView.setLayoutParams(params);
        listView.requestLayout();
    }

    public static boolean setListViewHeightBasedOnItems(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();
        if (listAdapter != null) {

            int numberOfItems = listAdapter.getCount();

            // Get total height of all items.
            int totalItemsHeight = 0;
            for (int itemPos = 0; itemPos < numberOfItems; itemPos++) {
                View item = listAdapter.getView(itemPos, null, listView);
                item.measure(0, 0);
                totalItemsHeight += item.getMeasuredHeight();
            }

            // Get total height of all item dividers.
            int totalDividersHeight = listView.getDividerHeight() *
                    (numberOfItems - 1);

            // Set list height.
            ViewGroup.LayoutParams params = listView.getLayoutParams();
            params.height = totalItemsHeight + totalDividersHeight;
            listView.setLayoutParams(params);
            listView.requestLayout();

            return true;

        } else {
            return false;
        }
    }

    public static void clearCache(Context context) {
        try {
            File dir = context.getCacheDir();
            if (dir != null && dir.isDirectory()) {
                deleteDir(dir);
            }
        } catch (Exception e) {

        }
    }

    public static void closeAppAlert(final Activity activity, String app_name) {
        AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(activity);

        alertDialogBuilder.setTitle(app_name);
        alertDialogBuilder.setMessage("Do you wish to close this app?");
        // set positive button: Yes message
        alertDialogBuilder.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int id) {
                // go to a new activity of the app
                dialog.cancel();
                activity.finish();
            }
        });
        // set negative button: No message
        alertDialogBuilder.setNegativeButton("No", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        // cancel the alert box and put a Toast to the user
                        dialog.cancel();
                    }
                }
        );


        AlertDialog alertDialog = alertDialogBuilder.create();
        // show alert
        alertDialog.show();
    }

    public static void setEditTextMaxLength(final EditText editText, int length) {
        InputFilter[] FilterArray = new InputFilter[1];
        FilterArray[0] = new InputFilter.LengthFilter(length);
        editText.setFilters(FilterArray);
    }

    public static boolean deleteDir(File dir) {
        if (dir != null && dir.isDirectory()) {
            String[] children = dir.list();
            for (int i = 0; i < children.length; i++) {
                boolean success = deleteDir(new File(dir, children[i]));
                if (!success) {
                    return false;
                }
            }
        }

        // The directory is now empty so delete it
        return dir.delete();
    }

    public static String manageSpecialChar(String res) {
//		String resp = res;
        String data = res;

        data = data.replace("&#xD;", "");
        data = data.replace("U+002B", "+");
        data = data.replace("U+0021", "!");
//		data = data.replace("U+0022", "\"");
        data = data.replace("U+0022", "'");
        data = data.replace("U+0023", "#");
        data = data.replace("U+0024", "$");
        data = data.replace("U+0025", "%");
        data = data.replace("U+0026", "&");
        data = data.replace("U+0027", "''");
        data = data.replace("U+002F", "/");


        data = data.replace("U 002B", "+");
        data = data.replace("U 0021", "!");
//		data = data.replace("U 0022", "\"");
        data = data.replace("U 0022", "'");
        data = data.replace("U 0023", "#");
        data = data.replace("U 0024", "$");
        data = data.replace("U 0025", "%");
        data = data.replace("U 0026", "&");
        data = data.replace("U 0027", "'");
        data = data.replace("U 002F", "/");
//		data = data.replace("&quot;", "\"");
        data = data.replace("&quot;", "'");
        data = data.replace("<null>", "");
        data = data.replace("null", "");
        data = data.replace("&#xD;", "");

        data = data.replace("&#8216;", "'");
        data = data.replace("&#8217;", "'");


        data = data.trim();

        return data;
    }


    public static void getDeviceDensity(Context context) {
        int density = context.getResources().getDisplayMetrics().densityDpi;
        Toast.makeText(context, "" + density, Toast.LENGTH_SHORT).show();
        Toast.makeText(context, "" + density, Toast.LENGTH_SHORT).show();
        Toast.makeText(context, "" + density, Toast.LENGTH_SHORT).show();
        Toast.makeText(context, "" + density, Toast.LENGTH_SHORT).show();

		/*switch(density)
		{
			case DisplayMetrics.DENSITY_LOW:
				Toast.makeText(context, "LDPI", Toast.LENGTH_SHORT).show();
				break;
			case DisplayMetrics.DENSITY_MEDIUM:
				Toast.makeText(context, "MDPI", Toast.LENGTH_SHORT).show();
				break;
			case DisplayMetrics.DENSITY_HIGH:
				Toast.makeText(context, "HDPI", Toast.LENGTH_SHORT).show();
				break;
			case DisplayMetrics.DENSITY_XHIGH:
				Toast.makeText(context, "XHDPI", Toast.LENGTH_SHORT).show();
				break;
		}*/
    }

    public static int getScreenWidth(Context context) {

        DisplayMetrics displayMetrics = context.getResources().getDisplayMetrics();
        float dpHeight = displayMetrics.heightPixels / displayMetrics.density;
        float dpWidth = displayMetrics.widthPixels / displayMetrics.density;

        return Math.round(dpWidth);
    }

    public static long getDays(Calendar fromDate, Calendar toDate) {
        long daysDiff = -1;
        try {
            long msDiff = toDate.getTimeInMillis() - fromDate.getTimeInMillis();
            daysDiff = TimeUnit.MILLISECONDS.toDays(msDiff);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return daysDiff;
    }


    //Compare Dates
    public static boolean betweenDates(Date date, Date dateStart, Date dateEnd) {
        if (date != null && dateStart != null && dateEnd != null) {
            if (date.after(dateStart) && date.before(dateEnd)) {
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    public static ContentValues getContentValuesFromJSON(JSONObject object) {

        ContentValues cv = new ContentValues();
        try {
            Iterator<?> keys = object.keys();

            while (keys.hasNext()) {
                try {
                    String key = (String) keys.next();
                    cv.put(key, object.getString(key));
                } catch (Exception e) {
                    printError(e);
                }


            }
        } catch (Exception e) {
            printError(e);
        }
        return cv;
    }


    // Check system AutoDate enable or not
    public static boolean isSystemAutoTime(Context context) {
        boolean checkMobileDate = false;
        try {


            if (Build.VERSION.SDK_INT >= 17) {

                if (android.provider.Settings.Global.getInt(context.getContentResolver(), android.provider.Settings.Global.AUTO_TIME, 0) == 1) {
                    // Enabled
                    checkMobileDate = true;
                } else {
                    // Disabed
                }

            } else {

                if (android.provider.Settings.System.getInt(context.getContentResolver(), android.provider.Settings.System.AUTO_TIME, 0) == 1) {
                    // Enabled
                    checkMobileDate = true;
                } else {
                    // Disabed
                }
            }
        } catch (Exception e) {
            printError(e);
        }
        return checkMobileDate;

    }

    public static void showDatePicker(Context c, final View v, final boolean showFutureDate) {
        final Calendar cal = Calendar.getInstance();
        final DatePickerDialog.OnDateSetListener date = new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                cal.set(Calendar.YEAR, year);
                cal.set(Calendar.MONTH, monthOfYear);
                cal.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                if (!showFutureDate) {
                    long time = System.currentTimeMillis();
                    view.setMaxDate(time);
                }
                updateDate();
            }

            private void updateDate() {
                // TODO Auto-generated method stub
//				String myFormat = "dd MMM. yyyy"; // In which you need put here
                String myFormat = "yyyy-MM-dd"; // In which you need put here
                SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.US);

                if (v instanceof EditText) {
                    ((EditText) v).setText(sdf.format(cal.getTime()));
                } else {
                    ((TextView) v).setText(sdf.format(cal.getTime()));
                }
            }

        };
        DatePickerDialog datePicker = new DatePickerDialog(c,
                date, cal.get(Calendar.YEAR), cal.get(Calendar.MONTH),
                cal.get(Calendar.DAY_OF_MONTH));

        datePicker.show();
    }

    public static boolean checkLimit(EditText editText) {

        boolean lengthFlag = false;
        try {

            if (editText.getText().toString().length() > textCharLimit) {
                lengthFlag = true;
            }

        } catch (Exception e) {

        }
        return lengthFlag;
    }

    public static ContentValues convertJSONTOContentValue(JSONObject object) {

        ContentValues contentValues = new ContentValues();
        try {

            Iterator iterator = object.keys();
            while (iterator.hasNext()) {
                String key = (String) iterator.next();

                contentValues.put(key, object.getString(key));
            }


        } catch (Exception e) {

        }
        return contentValues;
    }

    public static ArrayList<ContentValues> convertJSONTOContentValue(JSONArray array, String createStatement) {

        ArrayList<ContentValues> list = new ArrayList<ContentValues>();
        try {


            for (int i = 0; i < array.length(); i++) {

                JSONObject object = array.getJSONObject(i);
                ContentValues contentValues = new ContentValues();
                Iterator iterator = object.keys();
                while (iterator.hasNext()) {
                    String key = (String) iterator.next();

                    if (createStatement.contains(key)) {
                        contentValues.put(key, checkNULL(object.getString(key)));


                    }
                }
                list.add(contentValues);
            }

        } catch (Exception e) {

        }
        return list;
    }

    public static String checkNULL(String str) {

        String text = "";
        try {
            /*if (!str.equalsIgnoreCase("null") && str != null) {
                text = str;
            }*/

            if (str != null && !str.equalsIgnoreCase("null")) {
                text = str.trim();
            }

        } catch (Exception e) {

        }

        return text;
    }

    public static long checkNULL(long str) {

        String text = "";
        try {
            /*if (!str.equalsIgnoreCase("null") && str != null) {
                text = str;
            }*/


        } catch (Exception e) {

        }

        return str;
    }


    public static int getAppVersion(Context context) {

        int versionCode = 0;
        try {
            versionCode = context.getPackageManager().getPackageInfo(context.getPackageName(), 0).versionCode;
        } catch (PackageManager.NameNotFoundException e) {
            // TODO Auto-generated catch block

        }

        System.out.println("Version Code:" + versionCode);
        return versionCode;
    }

    public static void updateFromPlayStaore(Context context) {
        try {
            context.startActivity(new Intent(Intent.ACTION_VIEW, Uri
                    .parse("market://details?id="
                            + getPackageName(context))));
        } catch (android.content.ActivityNotFoundException anfe) {

        }
    }

    public static String getPackageName(Context context) {
        try {
            return context.getPackageManager().getPackageInfo(context.getPackageName(), 0).packageName;
        } catch (PackageManager.NameNotFoundException e) {
            // TODO Auto-generated catch block
            return "com.grantham.app";
        }


    }

    public static void showUpdateManditory(final Context context, String app_name) {

        try {
            AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(context);

            // set title
            alertDialogBuilder.setTitle(app_name);

            // set dialog message
            alertDialogBuilder
                    .setMessage("New update found, Do you want to update?")
                    .setCancelable(false)
                    .setPositiveButton("Yes",
                            new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog,
                                                    int id) {
                                    // if this button is clicked, close
                                    // current activity
                                    updateFromPlayStaore(context);
                                    ((Activity) context).finish();
                                }
                            })
                    .setNegativeButton("No",
                            new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog,
                                                    int id) {
                                    // if this button is clicked, just close
                                    // the dialog box and do nothing

                                    /*Closed app*/
                                    dialog.cancel();
                                    ((Activity) context).finish();
                                    System.exit(0);


                                    /* Intent i = new Intent(getBaseContext(), HomeActivity.class);
                                      startActivity(i);*/
                                    //Remove activity
                                    //     finish();
                                }
                            });

            // create alert dialog
            AlertDialog alertDialog = alertDialogBuilder.create();

            // show it
            alertDialog.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String formatFileSize(long size) {
        String hrSize = null;
        double b = size;
        double k = size/1024.0;
        double m = ((size/1024.0)/1024.0);
        double g = (((size/1024.0)/1024.0)/1024.0);
        double t = ((((size/1024.0)/1024.0)/1024.0)/1024.0);

        DecimalFormat dec1 = new DecimalFormat("0.00");
        DecimalFormat dec2 = new DecimalFormat("0");
        if (t>1) {
            hrSize = isDouble(t) ? dec1.format(t).concat(" TB") : dec2.format(t).concat(" TB");
        } else if (g>1) {
            hrSize = isDouble(g) ? dec1.format(g).concat(" GB") : dec2.format(g).concat(" GB");
        } else if (m>1) {
            hrSize = isDouble(m) ? dec1.format(m).concat(" MB") : dec2.format(m).concat(" MB");
        } else if (k>1) {
            hrSize = isDouble(k) ? dec1.format(k).concat(" KB") : dec2.format(k).concat(" KB");
        } else {
            hrSize = isDouble(b) ? dec1.format(b).concat(" B") : dec2.format(b).concat(" B");
        }
        return hrSize;
    }

    public static  boolean isDouble(double value) {
        if (value % 1 == 0) {
            //Log.d(Tag, "value is " + value + " and is not double");
            return false;
        } else {
         //   Log.d(TAG, "value is " + value + " and is double");
            return true;
        }
    }
}
