package com.react_sqlconnectionpackage.sqlconnection;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Build;
import android.preference.PreferenceManager;
import android.telephony.TelephonyManager;

import org.json.JSONObject;

public class DeviceInfo {

	private Context context = null;
	private String api_key = "";
	private String device_type = "";
	private String current_version = "";
	private String device_name = "";
	private String device_os = "";
	private String imei = "";

	private String language="";
	SharedPreferences settings = null;


	public String getLanguage() {
		return language;
	}

	public void setLanguage(String language) {
		this.language = language;
	}
	public DeviceInfo(){

	}
	public DeviceInfo(Context context){
		this.context = context;
		 settings = PreferenceManager
					.getDefaultSharedPreferences(context);
		 
		 
		 // Set Device information
		 try {
			 setApi_key();
			 setDevice_type();
			 setCurrent_version();
			 setDevice_name();
			 setDevice_os();
			 setImei();

		} catch (Exception e) {

		}
		
	}

	
	
	
	
	public String getApi_key() {
		return api_key;
	}

	public void setApi_key() {
		
		try {
			this.api_key = settings.getString("regID", "0");			
		} catch (Exception e) {


		}
		
	}

	public String getDevice_type() {
		return device_type;
	}

	public void setDevice_type() {
		this.device_type = "Android";
	}

	public String getCurrent_version() {
		return current_version;
	}

	public void setCurrent_version() {
		
//		String versionName = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
//		OR

		try {
			int versionCode = context.getPackageManager().getPackageInfo(context.getPackageName(), 0).versionCode;
//			String versionName =  context.getPackageManager().getPackageInfo( context.getPackageName(), 0).versionName;
			this.current_version = ""+versionCode;
		} catch (NameNotFoundException e) {

			e.printStackTrace();
		}
		
		
	}

	public JSONObject getUser_device() {

//		String versionName = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
//		OR

		JSONObject object = new JSONObject();
		try {
//			"api_key":"",
//					"imei":"123456789",
//					"device_type":"1",
//					"device_name":"Moto e3",
//					"device_os":"android 7.0"

			object.put("api_key","");
			object.put("imei",""+getImei());
			object.put("device_type",""+"Android");
			object.put("device_name",""+getDevice_name());
			object.put("device_os",""+getDevice_os());


		} catch ( Exception e) {

			e.printStackTrace();
		}

		return  object;

	}

	public String getDevice_name() {
		return device_name;
	}

	public void setDevice_name() {
		try {
			this.device_name = getDeviceName();
		} catch (Exception e) {

		}
	
	}

	public String getDevice_os() {
		return device_os;
	}

	public void setDevice_os() {
		this.device_os = getDeviceOS();
	}

	public String getImei() {

		try {
			TelephonyManager telephonyManager = (TelephonyManager) context
					.getSystemService(Context.TELEPHONY_SERVICE);
			String uniqueid = telephonyManager.getDeviceId()
					.toString();
			this.imei = uniqueid;
		} catch (Exception e) {
		e.printStackTrace();
		}
		return imei;
	}

	public void setImei() {
		try {
			TelephonyManager telephonyManager = (TelephonyManager) context
					.getSystemService(Context.TELEPHONY_SERVICE);
			String uniqueid = telephonyManager.getDeviceId()
					.toString();
			this.imei = uniqueid;
		} catch (Exception e) {

		}
		
	}
	
	
	
	///Global Methods
	public static String getDeviceName() {
		 
		 try {
			  String manufacturer = Build.MANUFACTURER;
			  String model = Build.MODEL;
			int version=  Build.VERSION.SDK_INT;
			  
			  if (model.startsWith(manufacturer)) {
			    return capitalize(model);
			  } else {
			    return capitalize(manufacturer) + " " + model;
			  }
		} catch (Exception e) {

		}
		 
		 return "";
		
		}
	 public static String getDeviceOS() {
		 String os = "";
		 try {
			 
			int version=  Build.VERSION.SDK_INT;
			os = ""+version;
			 
		} catch (Exception e) {

		}
		 
		 return os;
		
		}
	
	 private static String capitalize(String s) {
		  if (s == null || s.length() == 0) {
		    return "";
		  }
		  char first = s.charAt(0);
		  if (Character.isUpperCase(first)) {
		    return s;
		  } else {
		    return Character.toUpperCase(first) + s.substring(1);
		  }
		}
	public static String getCoutrySIMISO(Context context){

		TelephonyManager telephonyManager = (TelephonyManager)context.getSystemService(Context.TELEPHONY_SERVICE);
		return telephonyManager.getSimCountryIso();
	}
}
