package com.react_sqlconnectionpackage.sqlconnection;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.DownloadManager;
import android.content.ContentValues;
import android.content.Context;
import android.content.SharedPreferences;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.ReadableMapKeySetIterator;
import com.facebook.react.bridge.WritableArray;
import com.facebook.react.bridge.WritableMap;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.channels.FileChannel;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class GlobalData {


    public static DeviceInfo deviceInfo = null;

    public static final String SERVERAPIKEY = "abcd";



    //todo to Remove Date
    public static final String DB_DefaultDate = "1900-01-01 00:00:00";


    public  static ArrayList<Activity> activityList=new ArrayList<>();





    // Add Activity

    public  static void addActivity(Context context){
        try{

            activityList.add((Activity)context);
        }catch(Exception e){
            GlobalData.printError( e);
        }
    }

    public  static void finishAllActivity(){
        try{

            for(int i=0;i<activityList.size();i++){
                try{

                    Activity activity = activityList.get(i);
                    activity.finish();

                }catch(Exception e){
                    GlobalData.printError( e);
                }
            }
        }catch(Exception e){
            GlobalData.printError( e);
        }
    }

    // Convert JSON object to ContentValues
    public static ContentValues convertJSONTOContentValues(JSONObject jsonObject){

        ContentValues contentValues=new ContentValues();
        try{

            for(Iterator iter = jsonObject.keys(); iter.hasNext() ; ) {

                try{
                    String key = (String) iter.next();
                    contentValues.put(key,jsonObject.get(key).toString());

                }catch(Exception e){GlobalData.printError(e);}
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  contentValues;
    }

    // Convert JSON object to ContentValues
    public static JSONObject convertContentValuesTOJSON(ContentValues contentValues){

        JSONObject jsonObject =new JSONObject();
        try{

            for(Iterator iter = contentValues.keySet().iterator(); iter.hasNext() ; ) {

                try{
                    String key = (String) iter.next();
                    jsonObject.put(key,contentValues.get(key).toString());

                }catch(Exception e){GlobalData.printError(e);}
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  jsonObject;
    }


    // Convert JSON object to ContentValues

    // Convert JSON object to ContentValues
    public static ContentValues convertReadableMapTOContentValues(ReadableMap jsonObject){

        ContentValues contentValues=new ContentValues();
        try{

            for(ReadableMapKeySetIterator iter = jsonObject.keySetIterator(); iter.hasNextKey() ; ) {

                try{
                    String key = (String) iter.nextKey();
                    contentValues.put(key,jsonObject.getString(key));

                }catch(Exception e){GlobalData.printError(e);}
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  contentValues;
    }

    // Convert JSON object to ContentValues
    public static WritableMap convertContentValuesTOWritableMap(ContentValues contentValues){

        WritableMap jsonObject = Arguments.createMap();
        try{

            for(Iterator iter = contentValues.keySet().iterator(); iter.hasNext() ; ) {

                try{
                    String key = (String) iter.next();
                    jsonObject.putString(key,contentValues.get(key).toString());

                }catch(Exception e){GlobalData.printError(e);}
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  jsonObject;
    }

    // Convert JSON object to ContentValues
    public static WritableArray convertContentValuesTOWritableArray (ArrayList<ContentValues> contentValuesList){

        WritableArray array = Arguments.createArray();
        try{

            for (int i =0;i< contentValuesList.size();i++) {
                WritableMap jsonObject = Arguments.createMap();

                jsonObject = convertContentValuesTOWritableMap(contentValuesList.get(i));
                array.pushMap(jsonObject);
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  array;
    }


    public static ArrayList<ContentValues>  convertContentValuesTOReadableArray(ReadableArray readableArray){

        ArrayList<ContentValues> array = new ArrayList<>();
        try{

            for (int i =0;i< readableArray.size();i++) {
                ContentValues contentValues =new ContentValues();

                contentValues = convertReadableMapTOContentValues(readableArray.getMap(i));
                array.add(contentValues);
            }

        }catch(Exception e){GlobalData.printError(e);}
        return  array;
    }





    public static final File dbBackupDirectory = new File(Environment
            .getExternalStorageDirectory().getAbsolutePath()
            + "/Database/");

    public static void backupDBtoSDCard(Context context) {
        try {
            File databaseFile = context.getDatabasePath("database.db");
            File sd = Environment.getExternalStorageDirectory();

            boolean flag = false;
            try {
                if (!dbBackupDirectory.exists()) {
                    dbBackupDirectory.mkdirs();
                }
                flag = true;
            } catch (Exception e) {

                e.printStackTrace();
            }

            if (sd.canWrite()) {
                String backupDBPath = "database.db";
                if (flag) {
                    backupDBPath = dbBackupDirectory.getName() + "/database.db";
                }
                ;
                File backupDB = new File(sd, backupDBPath);


                if (databaseFile.exists()) {
                    FileChannel src = new FileInputStream(databaseFile)
                            .getChannel();
                    FileChannel dst = new FileOutputStream(backupDB)
                            .getChannel();
                    dst.transferFrom(src, 0, src.size());
                    src.close();
                    dst.close();
                }

                SharedPreferences setting = PreferenceManager.getDefaultSharedPreferences(context);
                SharedPreferences.Editor edit = setting.edit();

                edit.putString("file_location", backupDB.getAbsolutePath());
                Calendar c = Calendar.getInstance();
                c.setTimeInMillis(System.currentTimeMillis());
                edit.putString("file_backup_time", c.getTime().toLocaleString());
                edit.commit();
//                CommonUtil.showToast(context, "Database backed up successfully.");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    // Printing Message

    public static void printError(Exception e) {
        e.printStackTrace();
    }

    public static void printMessage(String m) {
        System.out.println(m);
    }


    public static long checkNULL(long str) {

        String text = "";
        try {
            /*if (!str.equalsIgnoreCase("null") && str != null) {
                text = str;
            }*/


        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return str;
    }

    public static String checkNULL(String str) {

        String text = "";
        try {
            /*if (!str.equalsIgnoreCase("null") && str != null) {
                text = str;
            }*/

            if (str != null && !str.equalsIgnoreCase("null")) {
                text = str.trim();
            }

        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return text;
    }

    public static long checkNULLL(String str) {

        long text = 0;
        try {

            text = Long.parseLong(str);

        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return text;
    }

    // Select Max Id From Table

    public static long getMaxIDValue(Context c, String tableName, String columnId) {
//        String sql = "SELECT MAX(cast( " + columnId + " as integer )) as " + columnId + " FROM  " + tableName +" where CenterId = '"+GlobalData.getCentreId(c)+"'";
        String sql = "SELECT MAX(cast( " + columnId + " as integer )) as " + columnId + " FROM  " + tableName + "  ";
        long idVal = 0;
        DatabaseHandler db = new DatabaseHandler(c);

        try {
            ArrayList<ContentValues> cvlist = db.select(sql);
            if (cvlist.size() > 0) {
                idVal = cvlist.get(0).getAsLong(columnId);
            }

        } catch (Exception e) {
            CommonUtil.printError(e);

        }


        return idVal;

    }


    public static void updateServerKey(Context c, String tableName, String primaryKey, long serverId) {
        String sql = "update " + tableName + " set serverId= " + serverId + " where " + primaryKey + "= " + serverId;

        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }

    }

    public static void updateSubseqenceTableIds(Context c, String tableName, String columName, String oldValue, String newvalue) {
        String sql = "update " + tableName + " set '" + columName + "'= '" + newvalue + "' where (isSynced = '2'  or isSynced = '0') and '" + columName + "'= '" + oldValue + "' ";

        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }

    }

    public static void updateServerKeywithAddCom(Context c, String tableName, String primaryKey, long serverId) {
        String sql = "update " + tableName + " set serverId= " + serverId + " where " + primaryKey + "= " + serverId;

        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }

    }

    public static void addReplicaKey(Context c, String tableName, String primaryKey, String replicaId, long primaryValue) {
        String sql = "update " + tableName + " set replicaId= '" + replicaId + "' where " + primaryKey + "= " + primaryValue;

        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }

    }


    public static void updateServerKeyFromServer(Context c, String tableName, String primaryKey, String mprimaryValue, long serverId, String Synced, String replicaId, String[] refKeys, String[] refValues) {


        String updateString = "";


        try {

            for (int i = 0; i < refKeys.length && i < refValues.length; i++) {
                try {


                    updateString = updateString + ", " + refKeys[i] + " = '" + refValues[i] + "' ";

                } catch (Exception e) {
                    GlobalData.printError(e);
                }
            }

        } catch (Exception e) {
            GlobalData.printError(e);
        }


        String sql = "update " + tableName + " set serverId= '" + serverId + "' , isSynced ='1', Synced = '" + Synced + "' " + updateString + " where " + primaryKey + "= '" + mprimaryValue + "' and replicaId='" + replicaId + "'";


        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }


    }

    public static void updateDefaulyKey(Context c, String tableName, String primaryKey, String primaryValue, String serverId) {
        String sql = "update " + tableName + " set " + primaryKey + " = '" + serverId + "' where " + primaryKey + "= " + primaryValue;

        DatabaseHandler db = new DatabaseHandler(c);

        try {

            db.execSQL(sql);


        } catch (Exception e) {
            CommonUtil.printError(e);

        }

    }

    public static String getReplicaId(Context context) {

        String replicaId = "";
        try {
            replicaId = CommonUtil.getIMEI(context) + "" + CommonUtil.getCurrantDatabaseDate(Calendar.getInstance().getTime());


        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return replicaId;
    }


    public static String getReplicaId(Context context, int count) {

        String replicaId = "";
        try {


            if (count > 0) {
                replicaId = CommonUtil.getIMEI(context) + "" + CommonUtil.getCurrantDatabaseDate(Calendar.getInstance().getTime()) + "-" + count;
            } else {
                replicaId = CommonUtil.getIMEI(context) + "" + CommonUtil.getCurrantDatabaseDate(Calendar.getInstance().getTime());
            }


        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return replicaId;
    }






    public static void hideSoftKeyboard(Context context) {
        try {
            InputMethodManager inputMethodManager = (InputMethodManager) context
                    .getSystemService(Activity.INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(((Activity) context)
                    .getCurrentFocus().getWindowToken(), 0);
        } catch (Exception e) {

            // GlobalData.printError(e);
        }
    }


    public static void showToast(Context context, String message ) {

        if (message.length() > 0) {
            Toast.makeText(context, message, Toast.LENGTH_LONG).show();
        }
    }


    public static void showDatePicker(Context context, final EditText etDate, boolean showNoFutureDate) {
        DatePickerDialog.OnDateSetListener date;
        final Calendar myCalendar = Calendar.getInstance();
        int maxDay = myCalendar.get(Calendar.DAY_OF_MONTH);
        date = new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                // TODO Auto-generated method stub
                myCalendar.set(Calendar.YEAR, year);
                myCalendar.set(Calendar.MONTH, monthOfYear);
                myCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                String myFormat = "yyyy-MM-dd";
                SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.US);
                etDate.setText(sdf.format(myCalendar.getTime()));
            }
        };
        DatePickerDialog dialog = new DatePickerDialog(context, date, myCalendar.get(Calendar.YEAR), myCalendar.get(Calendar.MONTH), maxDay);
        dialog.show();
        if (showNoFutureDate) {
            dialog.getDatePicker().setMaxDate(new Date().getTime());
        }
    }


    public static String getDecimalFormat(float num) {

        String val = "" + num;
        try {

            DecimalFormat df = new DecimalFormat();
            df.setMaximumFractionDigits(2);

            val = df.format(num);
        } catch (Exception e) {
            GlobalData.printError(e);
        }
        return val;

    }


    //Get MOd Date
    public static String getMAXModDate(Context c, String tableName) {
        DatabaseHandler db = new DatabaseHandler(c);
        String modDate = "modified_date";
        try {
            String sql = "PRAGMA table_info(" + tableName + ")";

            ArrayList<ContentValues> contentValues = new ArrayList<>();
            boolean isPresent = false;
            try {
                contentValues = db.select(sql);

                for (int i = 0; i < contentValues.size(); i++) {

                    if (contentValues.get(i).getAsString("name").equalsIgnoreCase(modDate)) {
                        isPresent = true;
                        break;

                    }
                }

            } catch (Exception e) {
                GlobalData.printError(e);
            }

            if (!isPresent) {
                modDate = "ModDate";
            }


        } catch (Exception e1) {
            GlobalData.printError(e1);
        }

        String sql = "SELECT MAX(( " + modDate + "  )) as " + modDate + " FROM  " + tableName;
        String idVal = "";


        try {
            ArrayList<ContentValues> cvlist = db.select(sql);
            if (cvlist.size() > 0) {
                idVal = cvlist.get(0).getAsString(modDate);
            }

        } catch (Exception e) {
            //   CommonUtil.printError(e);

        }


        return idVal;

    }



    public static boolean isSoftDelPresent(Context c, String tableName) {
        DatabaseHandler db = new DatabaseHandler(c);
        String softdel = "softdel";
        boolean isPresent = false;

            String sql = "PRAGMA table_info(" + tableName + ")";

            ArrayList<ContentValues> contentValues = new ArrayList<>();
              isPresent = false;
            try {
                contentValues = db.select(sql);

                for (int i = 0; i < contentValues.size(); i++) {

                    if (contentValues.get(i).getAsString("name").equalsIgnoreCase(softdel)) {
                        isPresent = true;
                        break;

                    }
                }

            } catch (Exception e) {
                GlobalData.printError(e);
            }

        return isPresent;

    }




    public static JSONObject getUserDatabaseJSON_offset_limit(Context context, JSONObject object, String tableName, int offset, int limit) {


        try {

            object.put(tableName + "_offset", "" + offset);
            object.put(tableName + "_limit", "" + limit);


        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return object;
    }

    public static JSONArray getTableDatabaseJSON(Context context, JSONArray array, boolean timeStampflag, String tableName, int offset, int limit) {
        //tblAnimalCatMst_timestamp

        try {


            String timeStamp = GlobalData.checkNULL(getMAXModDate(context, tableName));
            JSONObject object =new JSONObject();

            object.put("table_name",tableName);
            object.put("offset",offset);
            object.put("limit",limit);


            if (timeStamp.length() > 0 && timeStampflag) {


                object.put("timestamp",timeStamp);



            }else{


                object.put("timestamp","");
            }

            array.put(object);

        } catch (Exception e) {
            GlobalData.printError(e);
        }

        return array;
    }


    public static void SetSyncStatus(String sync_status, ImageView img_sync) {

        if (sync_status.equalsIgnoreCase("1") || sync_status.equalsIgnoreCase("2")) {
            img_sync.setVisibility(View.VISIBLE);
        } else {
            img_sync.setVisibility(View.GONE);
        }

    }


    // Check GPS is ON

    public static boolean isGPSON(Context context) {
        boolean statusOfGPS = false;
        try {

            LocationManager manager = (LocationManager) context.getSystemService(Context.LOCATION_SERVICE);

            if (manager.isProviderEnabled(LocationManager.GPS_PROVIDER) || manager.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {

                statusOfGPS = true;
            }
        } catch (Exception e) {
            GlobalData.printError(e);

        }
        return statusOfGPS;
    }





    public static long getIsSyncPending(Context c, String tableName) {
        String sql = "select * from " + tableName + " where isSynced like '0' or isSynced like '2'";
        long size = 0;
        DatabaseHandler db = new DatabaseHandler(c);

        try {
            ArrayList<ContentValues> cvlist = db.select(sql);
            size = cvlist.size();
        } catch (Exception e) {
            CommonUtil.printError(e);

        }


        return size;

    }

    public static void deleteAllTablesData(Context context) {
        // query to obtain the names of all tables in your database
        DatabaseHandler db = new DatabaseHandler(context);

        try {

            String sql = " SELECT name FROM sqlite_master WHERE type='table'";
            List<String> tables = new ArrayList<>();

            ArrayList<ContentValues> cvList = db.select(sql);

            for (int i = 0; i < cvList.size(); i++) {
                tables.add(cvList.get(i).getAsString("name"));
            }


// call DROP TABLE on every table name
            for (String table : tables) {
                String dropQuery = "delete from  " + table;
                db.execSQL(dropQuery);
            }
        } catch (Exception e) {
            GlobalData.printError(e);
        }
    }

//    public static void setAlertDialog(final Context context) {
//        android.support.v7.app.AlertDialog.Builder builder = new android.support.v7.app.AlertDialog.Builder(context);
//        builder.setCancelable(false);
//        builder.setTitle(context.getString(R.string.app_name));
//        builder.setMessage(R.string.close_msg);
//        builder.setPositiveButton(context.getResources().getString(R.string.yes), new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
//                //if user pressed "yes", then he is allowed to exit from application
//                ((Activity) context).finish();
//            }
//        });
//        builder.setNegativeButton(context.getResources().getString(R.string.no), new DialogInterface.OnClickListener() {
//            @Override
//            public void onClick(DialogInterface dialog, int which) {
//                //if user select "No", just cancel this dialog and continue with app
//                dialog.cancel();
//            }
//        });
//        android.support.v7.app.AlertDialog alert = builder.create();
//        alert.show();
//    }


    public static long removeTime(Calendar cal) {

        long time = cal.getTimeInMillis();

        try {
            cal.set(Calendar.HOUR_OF_DAY, 0);
            cal.set(Calendar.MINUTE, 0);
            cal.set(Calendar.SECOND, 0);
            cal.set(Calendar.MILLISECOND, 0);
            time = cal.getTimeInMillis();
        } catch (Exception e) {
            GlobalData.printError(e);
        }


        return time;
    }


    public static ContentValues addContentValue(ContentValues contentValuesFrom, ContentValues contentValuesAdd){

        try{

            for(String key: contentValuesAdd.keySet()){
                try{

                    if(!contentValuesFrom.containsKey(key)){
                        contentValuesFrom.put(key,contentValuesAdd.get(key).toString());
                    }
                }catch(Exception e){
                    GlobalData.printError( e);
                }
            }

        }catch(Exception e){
            GlobalData.printError( e);
        }

        return  contentValuesFrom;
    }



    public  static String getFileName(String fileLocation){

        String fileName="";
        try{
            try {
                String fullPath = fileLocation;
                int index = fullPath.lastIndexOf("\\");
                if (index <= 0) {
                    index = fullPath.lastIndexOf("/");
                }
                fileName = fullPath.substring(index + 1);
            } catch (Exception e) {
                GlobalData.printError(e);
            }
        }catch(Exception e){
            GlobalData.printError( e);
        }

        return  fileName;
    }




    // Doenalod File

    public static long DownloadData (Context context, String path ) {


        long downloadReference=-1;
        String fileName = "File Download";

        try{
            fileName = GlobalData.getFileName(path);
        }catch(Exception e){
            GlobalData.printError( e);
        }
        try{

            if(path.length()<=0){

                return downloadReference;
            }

            Uri uri = Uri.parse
                    (path);

        DownloadManager downloadManager;
        // Create request for android download manager
        downloadManager = (DownloadManager)context.getSystemService(Context.DOWNLOAD_SERVICE);
        DownloadManager.Request request = new DownloadManager.Request(uri);




        //Setting title of request
        request.setTitle(fileName);

        //Setting description of request
        request.setDescription("");
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.HONEYCOMB) {
                request.setShowRunningNotification(true);
            } else {
                request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
            }

        downloadReference = downloadManager.enqueue(request);

        }catch(Exception e){
            GlobalData.printError( e);
        }

        return downloadReference;
    }

    public static long DownloadDataLocal (Context context, String path, Uri uri ) {


        long downloadReference=-1;
        String fileName = "File Download";

        try{
            fileName = GlobalData.getFileName(path);
        }catch(Exception e){
            GlobalData.printError( e);
        }
        try{


            DownloadManager downloadManager;
            // Create request for android download manager
            downloadManager = (DownloadManager)context.getSystemService(Context.DOWNLOAD_SERVICE);
            DownloadManager.Request request = new DownloadManager.Request(uri);




            //Setting title of request
            request.setTitle(fileName);

            //Setting description of request
            request.setDescription("");
            if (Build.VERSION.SDK_INT < Build.VERSION_CODES.HONEYCOMB) {
                request.setShowRunningNotification(true);
            } else {
                request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
            }

            downloadReference = downloadManager.enqueue(request);

        }catch(Exception e){
            GlobalData.printError( e);
        }

        return downloadReference;
    }




    public static  void checkSystemTime(final Context context){

        int flag = 0;
        try{
         //   flag =  android.provider.Settings.Global.getInt(context.getContentResolver(), android.provider.Settings.Global.AUTO_TIME, 0);
           // android.provider.Settings.System.getInt(getContentResolver(), android.provider.Settings.System.AUTO_TIME, 0);

        }catch(Exception e){
            GlobalData.printError( e);
        }

        try{

//            if(flag<=0){
//
//                new AlertDialog.Builder(context)
//                        .setTitle(((Activity)context).getResources().getString(R.string.app_name))
//                        .setMessage(((Activity)context).getResources().getString(R.string.time_msg))
//                        .setPositiveButton(((Activity)context).getResources().getString(R.string.exit), new DialogInterface.OnClickListener() {
//                            @Override
//                            public void onClick(DialogInterface dialog, int which) {
//
//
//                                DatabaseHandler db=new DatabaseHandler(context);
//                                try{
//
//
//                                    System.exit(0);
//
//                                }catch(Exception e){
//                                    GlobalData.printError( e);
//                                }
//
//
//
//
//
//
//
//                            }
//
//                        })
//                        .setCancelable(false)
//                        .show();
//            }

        }catch(Exception e){
            GlobalData.printError( e);
        }
    }





//    public  static  boolean isValidFileExtenstion(Context context,String filePath){
//
//        boolean flag = false;
//
//        String ext = "";
//        try{
//           ext = getFileExtension(filePath);
//        }catch(Exception e){
//            GlobalData.printError( e);
//        }
//
//        try{
//            String extenssions = CommonUtil.getSharePreferenceString(context,GlobalData.SHARE_FILE_Extensions,"");
//
//            if(extenssions.contains(ext)){
//                flag = true;
//            }
//
//
//        }catch(Exception e){
//            GlobalData.printError( e);
//        }
//
//        return  flag;
//    }

   public static String getFileExtension(String url) {
        String[] urlSplit = url.split("/");
        String filename = urlSplit[urlSplit.length - 1];
        String[] nameSplit = filename.split("[.]");
        StringBuffer fileExtension = new StringBuffer();
// to prevent appending . after extension type
        if (nameSplit.length > 1) {
            for (int index = 1; index < nameSplit.length; index++) {
                if (index != nameSplit.length - 1)
                    fileExtension.append(nameSplit[index] + ".");
                else
                    fileExtension.append(nameSplit[index]);
            }
        } else {
            fileExtension.append(nameSplit[0]);
        }
        return fileExtension.toString();
    }


    public  static  boolean isValidFileSize(Context context, TextView textView, String filePath){

        boolean flag = false;
        double bytes = 0;
        try{
            File file =new File(filePath);

            if(file.exists()) {

                 bytes = file.length();
            }
        }catch(Exception e){
            GlobalData.printError( e);
        }

        try{
            String size = CommonUtil.getSharePreferenceString(context,"SHARE_FILE_Size","");

            long fileSize = Long.parseLong(size);
            if(bytes <= fileSize ){
                flag = true;
            }


        }catch(Exception e){
            GlobalData.printError( e);
        }

        if(!flag){
//            Toast.makeText(context,context.getResources().getString(R.string.msg_valid_file),Toast.LENGTH_LONG).show();
        //    GlobalData.showSnackBar(textView,context.getResources().getString(R.string.msg_valid_file_size),true);

        }

        return  flag;
    }

    public static boolean isValidExtension(Context context, TextView textView, String filePath) {
        boolean isValid = false;
        String extensions ="";
        try{
             extensions= CommonUtil.getSharePreferenceString(context,"SHARE_FILE_Extensions","");
        }catch(Exception e){
            GlobalData.printError( e);
        }

        try{


        String expression = "^*\\.("+extensions+")";
        String ext = getFileExtension(filePath);
            ext = "."+ext;
        CharSequence inputStr = ext;

        Pattern pattern = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
        Matcher matcher = pattern.matcher(inputStr);
        if (matcher.matches()) {
            isValid = true;
        }

        }catch(Exception e){
            GlobalData.printError( e);
        }


        if(!isValid){
//            GL.makeText(context,context.getResources().getString(R.string.msg_valid_file),Toast.LENGTH_LONG).show();
    //        GlobalData.showSnackBar(textView,context.getResources().getString(R.string.msg_valid_file_extension),true);
        }

        return isValid;
    }


    public static void copy(File src, File dst) throws IOException {
        InputStream in = new FileInputStream(src);
        try {
            OutputStream out = new FileOutputStream(dst);
            try {
                // Transfer bytes from in to out
                byte[] buf = new byte[1024];
                int len;
                while ((len = in.read(buf)) > 0) {
                    out.write(buf, 0, len);
                }
            } finally {
                out.close();
            }
        } finally {
            in.close();
        }
    }
}


