//  Created by react-native-create-bridge

package com.react_sqlconnectionpackage.sqlconnection;

import android.content.ContentValues;
import android.support.annotation.Nullable;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableArray;
import com.facebook.react.bridge.WritableArray;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.modules.core.DeviceEventManagerModule;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class SQLConnectionModule extends ReactContextBaseJavaModule {
    public static final String REACT_CLASS = "SQLConnection";
    private static ReactApplicationContext reactContext = null;

    private  DatabaseHandler databaseHandler = null;


    public SQLConnectionModule(ReactApplicationContext context) {
        // Pass in the context to the constructor and save it so you can emit events
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module
        super(context);

        reactContext = context;
    }

    @Override
    public String getName() {
        // Tell React the name of the module
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module
        return REACT_CLASS;
    }

    @Override
    public Map<String, Object> getConstants() {
        // Export any constants to be used in your native module
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module
        final Map<String, Object> constants = new HashMap<>();
        constants.put("EXAMPLE_CONSTANT", "example");

        return constants;
    }

    @ReactMethod
    public void exampleMethod () {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module
    }

    @ReactMethod
    public DatabaseHandler openDB () {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module

        try{
            databaseHandler=new DatabaseHandler(reactContext);


        }catch(Exception e){
            //    GlobalData.printError(e);
        }

        return databaseHandler;

    }

    @ReactMethod
    public WritableMap CreateTables (ReadableArray array, Callback callback) {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module

        String test = "Test Methods";
        System.out.println(test);
        final WritableMap event= Arguments.createMap();
        event.putString("key","temp");
        callback.invoke(test);

        try{
            databaseHandler.tables=new ArrayList<>();
            for (int i=0;i<array.size();i++){
                System.out.println(array.getString(i));
                databaseHandler.tables.add(array.getString(i));
            }
        }catch(Exception e){ }


        try{
            databaseHandler=new DatabaseHandler(reactContext);
            databaseHandler.open();
            databaseHandler.close();

        }catch(Exception e){
            //    GlobalData.printError(e);
        }
        return event;

    }



    @ReactMethod
    public DatabaseHandler getCountRows (String table, String primaryKey,Callback callback)  {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module

        int count =-1;
        try{
            databaseHandler=new DatabaseHandler(reactContext);
            try{
                databaseHandler.open();
                count= databaseHandler.countRows(table,primaryKey);
            }catch(Exception e){e.printStackTrace();}finally {
                databaseHandler.close();
            }
            WritableMap map = Arguments.createMap();
            map.putString("test",""+count);

            callback.invoke(""+count);
        }catch(Exception e){
            //    GlobalData.printError(e);
        }

        return databaseHandler;

    }

    @ReactMethod
    public void execute (String sql)  {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module


        try{
            databaseHandler=new DatabaseHandler(reactContext);

            try{
                databaseHandler.open();
                databaseHandler.execSQL(sql);
            }catch(Exception e){}finally {
                databaseHandler.close();
            }


        }catch(Exception e){
            //    GlobalData.printError(e);
        }
    }

    @ReactMethod
    public void Select (String sql,Callback callback)  {
        // An example native method that you will expose to React
        // https://facebook.github.io/react-native/docs/native-modules-android.html#the-toast-module


        try{
            databaseHandler=new DatabaseHandler(reactContext);

            try{
                databaseHandler.open();
                ArrayList<ContentValues> list=   databaseHandler.select(sql);

                WritableArray writableArray= GlobalData.convertContentValuesTOWritableArray(list);
                callback.invoke(writableArray);


            }catch(Exception e){}finally {
                databaseHandler.close();
            }


        }catch(Exception e){
            //    GlobalData.printError(e);
        }
    }

    private static void emitDeviceEvent(String eventName, @Nullable WritableMap eventData) {
        // A method for emitting from the native side to JS
        // https://facebook.github.io/react-native/docs/native-modules-android.html#sending-events-to-javascript
        reactContext.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class).emit(eventName, eventData);
    }
}
